﻿@page "/rounds"
@using Models.PlayerData
@using Models.RoundData
@using Cronus_Server.Pages.Competition.CompetitionRound.Dialog
@using Business.Repository.IRepository
@inject IRoundRepository RoundRepository
@inject IJSRuntime JsRuntime
@inject Blazored.LocalStorage.ILocalStorageService localStorage
@inject NavigationManager NavigationManager
@inject IModalDialogService ModalDialog

<div class="row mt-4">
    <div class="col-8">
        <h4 class="card-title text-info">Rounds</h4>
    </div>
    <div class="col-3 offset-1">
        <button @onclick="() => HandleAddRound(CompetitionId)" class="btn btn-primary form-control">Add new round</button>
    </div>
</div>
<div class="row mt-4">
    <div class="col-12">
        <table class="table table-bordered table-hover">
            <thead>
                <tr>
                    <th width="10%">#</th>
                    <th>Name</th>
                    <th width="10%">
                        Actions
                    </th>
                </tr>
            </thead>
            <tbody>
                @if (Rounds.Any())
                {
                    int i = 1;
                    @foreach (var round in Rounds)
                    {
                        <tr>
                            <td>@i</td>
                            @{i++;}
                            <td>@round.Name</td>
                            <td>
                                <button @onclick="() => HandleEditRound(CompetitionId, round.Id)" class="btn btn-primary">Edit</button>
                                <button class="btn btn-danger" @onclick="() => HandleDelete(round.Id)">Delete</button>
                            </td>
                        </tr>
                    }
                }
                else
                {
                    <tr>
                        <td colspan="5">No records found</td>
                    </tr>
                }
            </tbody>
        </table>
    </div>
</div>

<DeleteConfirmation IsParentComponentProcessing="IsProcessing" ConfirmationChanged="ConfirmDelete_Click"></DeleteConfirmation>

@code {
    [Parameter]
    public int CompetitionId { get; set; }
    private IEnumerable<RoundDTO> Rounds { get; set; } = new List<RoundDTO>();
    private int? DeleteRoundId { get; set; } = null;
    private bool IsProcessing { get; set; } = false;

    protected async override Task OnInitializedAsync()
    {
        Rounds = await RoundRepository.GetAllFromCompetition(CompetitionId);
    }

    private async Task HandleDelete(int roundId)
    {
        DeleteRoundId = roundId;
        await JsRuntime.InvokeVoidAsync("ShowDeleteConfirmationModal");
    }
    public async Task ConfirmDelete_Click(bool isConfirmed)
    {
        IsProcessing = true;
        if (isConfirmed && DeleteRoundId != null)
        {
            await RoundRepository.Delete(DeleteRoundId.Value);
            await JsRuntime.ToastrSuccess("Round deleted successfully!");
            Rounds = await RoundRepository.GetAllFromCompetition(CompetitionId);
        }
        await JsRuntime.InvokeVoidAsync("HideDeleteConfirmationModal");
        IsProcessing = false;
    }
    async void HandleAddRound(int competitionId)
    {
        var parameters = new ModalDialogParameters();
        parameters.Add("CompetitionId", CompetitionId);
        //Modal.Show<DialogAddPlayer>("Add players", parameters);
        var result = await ModalDialog.ShowDialogAsync<RoundCreateUpdate>("Add round", new ModalDialogOptions(), parameters);
        Rounds = await RoundRepository.GetAllFromCompetition(CompetitionId);
        StateHasChanged();
    }
    async void HandleEditRound(int competitionId, int roundId)
    {
        var parameters = new ModalDialogParameters();
        parameters.Add("CompetitionId", competitionId);
        parameters.Add("RoundId", roundId);
        //Modal.Show<DialogAddPlayer>("Add players", parameters);
        var result = await ModalDialog.ShowDialogAsync<RoundCreateUpdate>("Edit round", new ModalDialogOptions(), parameters);
        Rounds = await RoundRepository.GetAllFromCompetition(CompetitionId);
        StateHasChanged();
    }
}